SDL_test_memory.c File Reference
`#include "SDL_config.h"`
`#include "SDL_assert.h"`
`#include "SDL_stdinc.h"`
`#include "SDL_log.h"`
`#include "SDL_test_crc32.h"`
`#include "SDL_test_memory.h"`
Include dependency graph for SDL_test_memory.c:

Go to the source code of this file.

## Data Structures

struct | SDL_tracked_allocation

## Macros

#define | ADD_LINE()

## Functions

static unsigned int | get_allocation_bucket (void *mem)
static SDL_bool | SDL_IsAllocationTracked (void *mem)
static void | SDL_TrackAllocation (void *mem, size_t size)
static void | SDL_UntrackAllocation (void *mem)
static void * | SDLTest_TrackedMalloc (size_t size)
static void * | SDLTest_TrackedCalloc (size_t nmemb, size_t size)
static void * | SDLTest_TrackedRealloc (void *ptr, size_t size)
static void | SDLTest_TrackedFree (void *ptr)
int | SDLTest_TrackAllocations ()
| Start tracking SDL memory allocations. More...
void | SDLTest_LogAllocations ()
| Print a log of any outstanding allocations. More...

## Variables

static SDLTest_Crc32Context | s_crc32_context
static SDL_malloc_func | SDL_malloc_orig = NULL
static SDL_calloc_func | SDL_calloc_orig = NULL
static SDL_realloc_func | SDL_realloc_orig = NULL
static SDL_free_func | SDL_free_orig = NULL
static int | s_previous_allocations = 0
static SDL_tracked_allocation * | s_tracked_allocations [256]

## Macro Definition Documentation

## ADD_LINE

#define ADD_LINE | ( |  | ) |

Value:
message_size += (SDL_strlen(line) + 1); \
tmp = (char *)SDL_realloc_orig(message, message_size); \
if (!tmp) { \
return; \
} \
message = tmp; \
SDL_strlcat(message, line, message_size)

## Function Documentation

## get_allocation_bucket()

static unsigned int get_allocation_bucket | ( | void * | mem | ) |

static

Definition at line 56 of file SDL_test_memory.c.

{
CrcUint32 crc_value;
unsigned int index;
SDLTest_Crc32Calc(&s_crc32_context, (CrcUint8 *)&mem, sizeof(mem), &crc_value);
index = (crc_value & (SDL_arraysize(s_tracked_allocations) - 1));
return index;
}

References CrcUint32, CrcUint8, SDL_tracked_allocation::mem, s_crc32_context, s_tracked_allocations, SDL_arraysize, and SDLTest_Crc32Calc().

Referenced by SDL_IsAllocationTracked(), SDL_TrackAllocation(), and SDL_UntrackAllocation().

## SDL_IsAllocationTracked()

static SDL_bool SDL_IsAllocationTracked | ( | void * | mem | ) |

static

Definition at line 65 of file SDL_test_memory.c.

{
SDL_tracked_allocation *entry;
int index = get_allocation_bucket(mem);
for (entry = s_tracked_allocations[index]; entry; entry = entry->next) {
if (mem == entry->mem) {
return SDL_TRUE;
}
}
return SDL_FALSE;
}

References get_allocation_bucket(), SDL_tracked_allocation::mem, SDL_tracked_allocation::next, s_tracked_allocations, SDL_FALSE, and SDL_TRUE.

Referenced by SDL_TrackAllocation(), SDLTest_TrackedFree(), and SDLTest_TrackedRealloc().

## SDL_TrackAllocation()

static void SDL_TrackAllocation | ( | void * | mem,
|  | size_t | size
| ) |  |

static

Definition at line 77 of file SDL_test_memory.c.

{
SDL_tracked_allocation *entry;
int index = get_allocation_bucket(mem);
if (SDL_IsAllocationTracked(mem)) {
return;
}
entry = (SDL_tracked_allocation *)SDL_malloc_orig(sizeof(*entry));
if (!entry) {
return;
}
entry->mem = mem;
entry->size = size;
/* Generate the stack trace for the allocation */
SDL_zero(entry->stack);
#ifdef HAVE_LIBUNWIND_H
{
int stack_index;
unw_cursor_t cursor;
unw_context_t context;
unw_getcontext(&context);
unw_init_local(&cursor, &context);
stack_index = 0;
while (unw_step(&cursor) > 0) {
unw_word_t offset, pc;
char sym[256];
unw_get_reg(&cursor, UNW_REG_IP, &pc);
entry->stack[stack_index] = pc;
if (unw_get_proc_name(&cursor, sym, sizeof(sym), &offset) == 0) {
snprintf(entry->stack_names[stack_index], sizeof(entry->stack_names[stack_index]), "%s+0x%llx", sym, (unsigned long long)offset);
}
++stack_index;
if (stack_index == SDL_arraysize(entry->stack)) {
break;
}
}
}
#endif /* HAVE_LIBUNWIND_H */
entry->next = s_tracked_allocations[index];
s_tracked_allocations[index] = entry;
}

References context, cursor, get_allocation_bucket(), SDL_tracked_allocation::mem, SDL_tracked_allocation::next, s_tracked_allocations, SDL_arraysize, SDL_IsAllocationTracked(), SDL_malloc_orig, SDL_zero, SDL_tracked_allocation::size, SDL_tracked_allocation::stack, and SDL_tracked_allocation::stack_names.

Referenced by SDLTest_TrackedCalloc(), SDLTest_TrackedMalloc(), and SDLTest_TrackedRealloc().

## SDL_UntrackAllocation()

static void SDL_UntrackAllocation | ( | void * | mem | ) |

static

Definition at line 127 of file SDL_test_memory.c.

{
SDL_tracked_allocation *entry, *prev;
int index = get_allocation_bucket(mem);
prev = NULL;
for (entry = s_tracked_allocations[index]; entry; entry = entry->next) {
if (mem == entry->mem) {
if (prev) {
prev->next = entry->next;
} else {
s_tracked_allocations[index] = entry->next;
}
SDL_free_orig(entry);
return;
}
prev = entry;
}
}

References get_allocation_bucket(), SDL_tracked_allocation::mem, SDL_tracked_allocation::next, NULL, s_tracked_allocations, and SDL_free_orig.

Referenced by SDLTest_TrackedFree(), and SDLTest_TrackedRealloc().

## SDLTest_LogAllocations()

void SDLTest_LogAllocations | ( | void |  | ) |

Print a log of any outstanding allocations.

Note
  This can be called after SDL_Quit()

Definition at line 222 of file SDL_test_memory.c.

{
char *message = NULL;
size_t message_size = 0;
char line[128], *tmp;
SDL_tracked_allocation *entry;
int index, count, stack_index;
Uint64 total_allocated;
if (!SDL_malloc_orig) {
return;
}
#define ADD_LINE() \
message_size += (SDL_strlen(line) + 1); \
tmp = (char *)SDL_realloc_orig(message, message_size); \
if (!tmp) { \
return; \
} \
message = tmp; \
SDL_strlcat(message, line, message_size)
SDL_strlcpy(line, "Memory allocations:\n", sizeof(line));
ADD_LINE();
SDL_strlcpy(line, "Expect 2 allocations from within SDL_GetErrBuf()\n", sizeof(line));
ADD_LINE();
count = 0;
total_allocated = 0;
for (index = 0; index < SDL_arraysize(s_tracked_allocations); ++index) {
for (entry = s_tracked_allocations[index]; entry; entry = entry->next) {
SDL_snprintf(line, sizeof(line), "Allocation %d: %d bytes\n", count, (int)entry->size);
ADD_LINE();
/* Start at stack index 1 to skip our tracking functions */
for (stack_index = 1; stack_index < SDL_arraysize(entry->stack); ++stack_index) {
if (!entry->stack[stack_index]) {
break;
}
SDL_snprintf(line, sizeof(line), "\t0x%"SDL_PRIx64": %s\n", entry->stack[stack_index], entry->stack_names[stack_index]);
ADD_LINE();
}
total_allocated += entry->size;
++count;
}
}
SDL_snprintf(line, sizeof(line), "Total: %.2f Kb in %d allocations\n", (float)total_allocated / 1024, count);
ADD_LINE();
#undef ADD_LINE
SDL_Log("%s", message);
}

References ADD_LINE, SDL_tracked_allocation::next, NULL, s_tracked_allocations, SDL_arraysize, SDL_Log, SDL_malloc_orig, SDL_PRIx64, SDL_snprintf, SDL_strlcpy, SDL_tracked_allocation::size, SDL_tracked_allocation::stack, and SDL_tracked_allocation::stack_names.

Referenced by SDLTest_CommonQuit().

## SDLTest_TrackAllocations()

int SDLTest_TrackAllocations | ( | void |  | ) |

Start tracking SDL memory allocations.

Note
  This should be called before any other SDL functions for complete tracking coverage

Definition at line 197 of file SDL_test_memory.c.

{
if (SDL_malloc_orig) {
return 0;
}
SDLTest_Crc32Init(&s_crc32_context);
s_previous_allocations = SDL_GetNumAllocations();
if (s_previous_allocations != 0) {
SDL_Log("SDLTest_TrackAllocations(): There are %d previous allocations, disabling free() validation", s_previous_allocations);
}
SDL_GetMemoryFunctions(&SDL_malloc_orig,
&SDL_calloc_orig,
&SDL_realloc_orig,
&SDL_free_orig);
SDL_SetMemoryFunctions(SDLTest_TrackedMalloc,
SDLTest_TrackedCalloc,
SDLTest_TrackedRealloc,
SDLTest_TrackedFree);
return 0;
}

References s_crc32_context, s_previous_allocations, SDL_calloc_orig, SDL_free_orig, SDL_GetMemoryFunctions, SDL_GetNumAllocations, SDL_Log, SDL_malloc_orig, SDL_realloc_orig, SDL_SetMemoryFunctions, SDLTest_Crc32Init(), SDLTest_TrackedCalloc(), SDLTest_TrackedFree(), SDLTest_TrackedMalloc(), and SDLTest_TrackedRealloc().

Referenced by SDLTest_CommonCreateState().

## SDLTest_TrackedCalloc()

static void* SDLTest_TrackedCalloc | ( | size_t | nmemb,
|  | size_t | size
| ) |  |

static

Definition at line 158 of file SDL_test_memory.c.

{
void *mem;
mem = SDL_calloc_orig(nmemb, size);
if (mem) {
SDL_TrackAllocation(mem, nmemb * size);
}
return mem;
}

References SDL_tracked_allocation::mem, SDL_calloc_orig, and SDL_TrackAllocation().

Referenced by SDLTest_TrackAllocations().

## SDLTest_TrackedFree()

static void SDLTest_TrackedFree | ( | void * | ptr | ) |

static

Definition at line 184 of file SDL_test_memory.c.

{
if (!ptr) {
return;
}
if (!s_previous_allocations) {
SDL_assert(SDL_IsAllocationTracked(ptr));
}
SDL_UntrackAllocation(ptr);
SDL_free_orig(ptr);
}

References s_previous_allocations, SDL_assert, SDL_free_orig, SDL_IsAllocationTracked(), and SDL_UntrackAllocation().

Referenced by SDLTest_TrackAllocations().

## SDLTest_TrackedMalloc()

static void* SDLTest_TrackedMalloc | ( | size_t | size | ) |

static

Definition at line 147 of file SDL_test_memory.c.

{
void *mem;
mem = SDL_malloc_orig(size);
if (mem) {
SDL_TrackAllocation(mem, size);
}
return mem;
}

References SDL_tracked_allocation::mem, SDL_malloc_orig, and SDL_TrackAllocation().

Referenced by SDLTest_TrackAllocations().

## SDLTest_TrackedRealloc()

static void* SDLTest_TrackedRealloc | ( | void * | ptr,
|  | size_t | size
| ) |  |

static

Definition at line 169 of file SDL_test_memory.c.

{
void *mem;
SDL_assert(!ptr || SDL_IsAllocationTracked(ptr));
mem = SDL_realloc_orig(ptr, size);
if (mem && mem != ptr) {
if (ptr) {
SDL_UntrackAllocation(ptr);
}
SDL_TrackAllocation(mem, size);
}
return mem;
}

References SDL_tracked_allocation::mem, SDL_assert, SDL_IsAllocationTracked(), SDL_realloc_orig, SDL_TrackAllocation(), and SDL_UntrackAllocation().

Referenced by SDLTest_TrackAllocations().

## Variable Documentation

## s_crc32_context

SDLTest_Crc32Context s_crc32_context

static

Definition at line 48 of file SDL_test_memory.c.

Referenced by get_allocation_bucket(), and SDLTest_TrackAllocations().

## s_previous_allocations

int s_previous_allocations = 0

static

Definition at line 53 of file SDL_test_memory.c.

Referenced by SDLTest_TrackAllocations(), and SDLTest_TrackedFree().

## s_tracked_allocations

SDL_tracked_allocation* s_tracked_allocations[256]

static

Definition at line 54 of file SDL_test_memory.c.

Referenced by get_allocation_bucket(), SDL_IsAllocationTracked(), SDL_TrackAllocation(), SDL_UntrackAllocation(), and SDLTest_LogAllocations().

## SDL_calloc_orig

SDL_calloc_func SDL_calloc_orig = NULL

static

Definition at line 50 of file SDL_test_memory.c.

Referenced by SDLTest_TrackAllocations(), and SDLTest_TrackedCalloc().

## SDL_free_orig

SDL_free_func SDL_free_orig = NULL

static

Definition at line 52 of file SDL_test_memory.c.

Referenced by SDL_UntrackAllocation(), SDLTest_TrackAllocations(), and SDLTest_TrackedFree().

## SDL_malloc_orig

SDL_malloc_func SDL_malloc_orig = NULL

static

Definition at line 49 of file SDL_test_memory.c.

Referenced by SDL_TrackAllocation(), SDLTest_LogAllocations(), SDLTest_TrackAllocations(), and SDLTest_TrackedMalloc().

## SDL_realloc_orig

SDL_realloc_func SDL_realloc_orig = NULL

static

Definition at line 51 of file SDL_test_memory.c.

Referenced by SDLTest_TrackAllocations(), and SDLTest_TrackedRealloc().

SDL_zero
#define SDL_zero(x)
Definition: SDL_stdinc.h:416
SDL_IsAllocationTracked
static SDL_bool SDL_IsAllocationTracked(void *mem)
Definition: SDL_test_memory.c:65
SDL_strlcpy
#define SDL_strlcpy
Definition: SDL_dynapi_overrides.h:394
offset
GLintptr offset
Definition: SDL_opengl_glext.h:538
NULL
#define NULL
Definition: begin_code.h:167
message
GLuint GLsizei const GLchar * message
Definition: SDL_opengl_glext.h:2483
SDL_PRIx64
#define SDL_PRIx64
Definition: SDL_stdinc.h:249
SDLTest_TrackedRealloc
static void * SDLTest_TrackedRealloc(void *ptr, size_t size)
Definition: SDL_test_memory.c:169
count
GLuint GLuint GLsizei count
Definition: SDL_opengl.h:1571
SDL_SetMemoryFunctions
#define SDL_SetMemoryFunctions
Definition: SDL_dynapi_overrides.h:641
s_previous_allocations
static int s_previous_allocations
Definition: SDL_test_memory.c:53
SDL_tracked_allocation::stack
Uint64 stack[10]
Definition: SDL_test_memory.c:43
index
GLuint index
Definition: SDL_opengl_glext.h:660
SDL_realloc_orig
static SDL_realloc_func SDL_realloc_orig
Definition: SDL_test_memory.c:51
SDL_UntrackAllocation
static void SDL_UntrackAllocation(void *mem)
Definition: SDL_test_memory.c:127
SDL_FALSE
@ SDL_FALSE
Definition: SDL_stdinc.h:163
context
static screen_context_t context
Definition: video.c:25
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
ADD_LINE
#define ADD_LINE()
s_tracked_allocations
static SDL_tracked_allocation * s_tracked_allocations[256]
Definition: SDL_test_memory.c:54
s_crc32_context
static SDLTest_Crc32Context s_crc32_context
Definition: SDL_test_memory.c:48
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:169
get_allocation_bucket
static unsigned int get_allocation_bucket(void *mem)
Definition: SDL_test_memory.c:56
SDL_malloc_orig
static SDL_malloc_func SDL_malloc_orig
Definition: SDL_test_memory.c:49
SDL_tracked_allocation
Definition: SDL_test_memory.c:39
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
size
GLsizeiptr size
Definition: SDL_opengl_glext.h:537
SDLTest_Crc32Init
int SDLTest_Crc32Init(SDLTest_Crc32Context *crcContext)
Initialize the CRC context.
Definition: SDL_test_crc32.c:34
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:115
SDL_GetMemoryFunctions
#define SDL_GetMemoryFunctions
Definition: SDL_dynapi_overrides.h:640
SDL_tracked_allocation::next
struct SDL_tracked_allocation * next
Definition: SDL_test_memory.c:45
SDL_TRUE
@ SDL_TRUE
Definition: SDL_stdinc.h:164
SDL_snprintf
#define SDL_snprintf
Definition: SDL_dynapi_overrides.h:40
Uint64
uint64_t Uint64
Definition: SDL_stdinc.h:216
SDL_tracked_allocation::size
size_t size
Definition: SDL_test_memory.c:42
CrcUint32
#define CrcUint32
Definition: SDL_test_crc32.h:51
SDL_free_orig
static SDL_free_func SDL_free_orig
Definition: SDL_test_memory.c:52
SDL_strlen
#define SDL_strlen
Definition: SDL_dynapi_overrides.h:393
SDL_tracked_allocation::mem
void * mem
Definition: SDL_test_memory.c:41
SDL_tracked_allocation::stack_names
char stack_names[10][256]
Definition: SDL_test_memory.c:44
SDL_GetNumAllocations
#define SDL_GetNumAllocations
Definition: SDL_dynapi_overrides.h:642
SDLTest_TrackedCalloc
static void * SDLTest_TrackedCalloc(size_t nmemb, size_t size)
Definition: SDL_test_memory.c:158
SDLTest_TrackedMalloc
static void * SDLTest_TrackedMalloc(size_t size)
Definition: SDL_test_memory.c:147
SDLTest_TrackedFree
static void SDLTest_TrackedFree(void *ptr)
Definition: SDL_test_memory.c:184
SDL_calloc_orig
static SDL_calloc_func SDL_calloc_orig
Definition: SDL_test_memory.c:50
SDL_TrackAllocation
static void SDL_TrackAllocation(void *mem, size_t size)
Definition: SDL_test_memory.c:77
CrcUint8
#define CrcUint8
Definition: SDL_test_crc32.h:54
SDLTest_Crc32Calc
int SDLTest_Crc32Calc(SDLTest_Crc32Context *crcContext, CrcUint8 *inBuf, CrcUint32 inLen, CrcUint32 *crc32)
calculate a crc32 from a data block
Definition: SDL_test_crc32.c:72